VERSION 5.00
Object = "{0A77CCF5-052C-11D6-B0EC-00B0D074179C}#1.0#0"; "Tws.ocx"
Begin VB.Form Form1 
   Caption         =   "Sends A Buy MKT order, with autobracket STP and LMT Orders"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6435
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   6435
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox TextDelay 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   4200
      TabIndex        =   10
      Text            =   "1.4"
      Top             =   360
      Width           =   615
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Start Ticker"
      Default         =   -1  'True
      Height          =   615
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1095
   End
   Begin VB.PictureBox Picture1 
      Align           =   2  'Align Bottom
      Height          =   1815
      Left            =   0
      ScaleHeight     =   1755
      ScaleWidth      =   6375
      TabIndex        =   6
      Top             =   1380
      Width           =   6435
      Begin VB.TextBox TextStatus 
         Height          =   1335
         Left            =   120
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   7
         Top             =   120
         Width           =   6015
      End
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Close Position"
      Height          =   615
      Left            =   2520
      TabIndex        =   3
      Top             =   120
      Width           =   1095
   End
   Begin TWSLib.Tws Tws1 
      Height          =   975
      Left            =   2040
      TabIndex        =   2
      Top             =   840
      Visible         =   0   'False
      Width           =   1935
      _Version        =   65536
      _ExtentX        =   3413
      _ExtentY        =   1720
      _StockProps     =   0
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Open Position"
      Height          =   615
      Left            =   1320
      TabIndex        =   1
      Top             =   120
      Width           =   1095
   End
   Begin VB.Label Label4 
      Caption         =   "Set to zero to see error caused by bug"
      Height          =   495
      Left            =   4080
      TabIndex        =   11
      Top             =   720
      Width           =   1575
      WordWrap        =   -1  'True
   End
   Begin VB.Label Label3 
      Caption         =   "Secs"
      Height          =   375
      Left            =   4920
      TabIndex        =   9
      Top             =   360
      Width           =   615
   End
   Begin VB.Label Label2 
      Caption         =   "Delay Between Orders:"
      Height          =   255
      Left            =   4080
      TabIndex        =   8
      Top             =   120
      Width           =   1695
   End
   Begin VB.Label LabelLastPrice 
      Height          =   255
      Left            =   1200
      TabIndex        =   5
      Top             =   960
      Width           =   975
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "ES Last Price:"
      Height          =   255
      Left            =   0
      TabIndex        =   4
      Top             =   960
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim TheirNextOrderId As Long
Dim NewID As Long
Dim LastPrice As Double
Dim LimitOrderId As Long
Dim Button1 As Boolean
Dim WaitTime As Single

Private Sub Command1_Click()
    Dim ParentOrderId As Long
    If LastPrice = 0 Then
        MsgBox "Start ticker first"
        Exit Sub
    End If
    Button1 = True
    WaitTime = CSng(TextDelay.Text)
    Tws1.transmit = False
    Tws1.ParentId = 0
    NewID = NewID + 1
    Call Tws1.placeOrder(NewID, "BUY", 1, "ES", "FUT", "200303", 0, "", "GLOBEX", "", "MKT", 0#, 0#)
    Call WaitXseconds(WaitTime)
    Call ShowStatusMsg("Sent Order " & NewID)
    ParentOrderId = NewID
    Tws1.transmit = False
    Tws1.ParentId = ParentOrderId
    NewID = NewID + 1
    LimitOrderId = NewID 'save this for the close position request
    Call Tws1.placeOrder(NewID, "SELL", 1, "ES", "FUT", "200303", 0, "", "GLOBEX", "", "LMT", LastPrice + 3, 0#)
    Call WaitXseconds(WaitTime)
    Call ShowStatusMsg("Sent Order " & NewID)
    Tws1.transmit = True
    Tws1.ParentId = ParentOrderId
    NewID = NewID + 1
    Call Tws1.placeOrder(NewID, "SELL", 1, "ES", "FUT", "200303", 0, "", "GLOBEX", "", "STP", LastPrice - 3, LastPrice - 3)
    Call WaitXseconds(WaitTime)
    Call ShowStatusMsg("Sent Order " & NewID)
End Sub

Private Sub Command2_Click()
    'modifies open position's exit limit order to close position
    Dim OldID As Long
    If Not Button1 Then
        MsgBox "Press 'Open Position'  first"
        Exit Sub
    End If
    Button1 = False
    Tws1.transmit = True
    Tws1.ParentId = 0
    OldID = LimitOrderId
    Call Tws1.placeOrder(OldID, "SELL", 1, "ES", "FUT", "200303", 0, "", "GLOBEX", "", "LMT", LastPrice - 3, 0#)
    Call ShowStatusMsg("Sent ReplaceOrder " & OldID)
End Sub

Private Sub Command3_Click()
    Call Tws1.reqMktData(111, "ES", "FUT", "200303", 0, "", "GLOBEX", "")
    Do
        DoEvents
    Loop Until LastPrice > 0
End Sub

Private Sub ShowStatusMsg(Msg As String)
    On Error GoTo ErrorExit
    If Len(TextStatus.Text) = 0 Then
        TextStatus.Text = Msg$
    Else
        TextStatus.Text = TextStatus.Text & vbCrLf & Msg$
    End If
    TextStatus.SelStart = Len(TextStatus.Text)
    Exit Sub
ErrorExit:
    MsgBox "Error in ShowStatusMsg. Error: " & Err.Description
    Exit Sub
End Sub

Private Sub WaitXseconds(ByVal X As Single)
Dim EntryTime As Single
    EntryTime = Timer
    Do
        DoEvents
        If EntryTime > Timer Then EntryTime = Timer 'midnight rollover
    Loop Until EntryTime + X < Timer
End Sub

Private Sub Form_Load()
    Tws1.Connect "", 7496, 0
End Sub

Private Sub Form_Resize()
    If Me.Visible Then
        If Not Me.WindowState = vbMinimized Then
            'Picture1.Top = 1380
            Picture1.Height = Me.ScaleHeight - 1380
            TextStatus.Top = 0
            TextStatus.Left = 0
            TextStatus.Width = Picture1.ScaleWidth
            TextStatus.Height = Picture1.ScaleHeight
        End If
    End If

End Sub

Private Sub Tws1_nextValidId(ByVal id As Long)
    TheirNextOrderId = id
    If NewID <= TheirNextOrderId Then
        NewID = TheirNextOrderId + 1
    End If
End Sub

Private Sub Tws1_errMsg(ByVal id As Long, ByVal errorCode As Long, ByVal errorMsg As String)
    Dim OrderId As String
    Dim theMsg() As String
    Dim i As Long
    OrderId = CStr(id)
    If Len(errorMsg) > 0 Then
        theMsg() = Split(errorMsg, vbLf)
        errorMsg = theMsg(0)
        For i = 1 To UBound(theMsg)
            errorMsg = errorMsg & " " & theMsg(i)
        Next
    End If
    If id < TheirNextOrderId Then
        Call ShowStatusMsg("Err " & CStr(errorCode) & "=" & errorMsg)
    Else
        Call ShowStatusMsg("Err for Order " & OrderId & ", " & CStr(errorCode) & "=" & errorMsg)
    End If
End Sub

Private Sub Tws1_orderStatus(ByVal id As Long, ByVal Status As String, ByVal Filled As Long, ByVal Remaining As Long, ByVal Price As Double, ByVal PermId As Long, ByVal ParentId As Long)
    Dim Msg As String
    Msg = "Status for Order " & CStr(id)
    Msg = Msg & ", Status=" & Status
    Msg = Msg & ", filled=" & CStr(Filled) & ", remaining=" & CStr(Remaining) & ", price=" & Format$(Price, "#####0.00#")
    ShowStatusMsg Msg
End Sub

Private Sub Tws1_tickPrice(ByVal id As Long, ByVal tickType As Long, ByVal Price As Double)
    If tickType = 4 Then 'last price
        LabelLastPrice.Caption = Format$(Price, "#####0.00#")
        LastPrice = Price
    End If
End Sub

