VERSION 5.00
Object = "{0A77CCF5-052C-11D6-B0EC-00B0D074179C}#1.0#0"; "Tws.ocx"
Object = "{0ECD9B60-23AA-11D0-B351-00A0C9055D8E}#6.0#0"; "MSHFLXGD.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7350
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10980
   LinkTopic       =   "Form1"
   ScaleHeight     =   7350
   ScaleWidth      =   10980
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox Combo1 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   420
      Left            =   3360
      TabIndex        =   4
      Text            =   "Select Stocks or Futures"
      Top             =   60
      Width           =   4155
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Connect"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   780
      Width           =   1215
   End
   Begin TWSLib.Tws Tws1 
      Height          =   375
      Left            =   60
      TabIndex        =   2
      Top             =   60
      Width           =   3195
      _Version        =   65536
      _ExtentX        =   5636
      _ExtentY        =   661
      _StockProps     =   0
   End
   Begin VB.TextBox txtCellEditor 
      Appearance      =   0  'Flat
      BorderStyle     =   0  'None
      Height          =   435
      Left            =   8220
      TabIndex        =   1
      Text            =   "Text1"
      Top             =   960
      Visible         =   0   'False
      Width           =   1155
   End
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid hFlexGrid 
      Height          =   5595
      Left            =   120
      TabIndex        =   0
      Top             =   1620
      Width           =   10215
      _ExtentX        =   18018
      _ExtentY        =   9869
      _Version        =   393216
      Rows            =   40
      Cols            =   10
      ScrollBars      =   2
      _NumberOfBands  =   1
      _Band(0).Cols   =   10
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Command1_Click()

   'call for the connection
   'your TWS must be up and running in order to connect
    Tws1.Connect "", 7496
    
End Sub

Private Sub Form_Load()

   Dim iTemp As Integer
   Dim iTemp2 As Integer
   Dim Cancel As Boolean
   
   'grid formating stuff
   With hFlexGrid
      .Col = 0
      .Row = 0
      .ColSel = .Cols - 1
      .RowSel = .Rows - 1
      .FillStyle = flexFillRepeat
      .CellFontBold = True
      .CellAlignment = flexAlignCenterCenter
      .TextMatrix(0, 1) = "Symbol"
      .TextMatrix(0, 2) = "B-Size"
      .TextMatrix(0, 3) = "Bid"
      .TextMatrix(0, 4) = "Ask"
      .TextMatrix(0, 5) = "A-Size"
      .TextMatrix(0, 6) = "Last"
      .TextMatrix(0, 7) = "L-Size"
      .Col = 1
      .Row = 1
      .ColWidth(0) = .RowHeight(0) + 50
      'number the first column and alternate the row colors
      For iTemp = 1 To .Rows - 1
         .TextMatrix(iTemp, 0) = iTemp
      If Not Cancel Then
         For iTemp2 = 1 To .Cols - 1
            .Row = iTemp
            .Col = iTemp2
            .CellBackColor = &HE0E0E0
            Cancel = True
         Next iTemp2
      Else
         Cancel = False
      End If
      
      Next iTemp
      
      'adds a couple of items to the combo box
      Combo1.AddItem "Stocks, Instinet"
      Combo1.AddItem "Futures, Globex, 200212"
      
      
   End With
   
  
   
End Sub

Private Sub hFlexGrid_DblClick()
   'calls the grid editor when you double click a cell
   Call GridEdit(Asc(" "))
End Sub

Private Sub hFlexGrid_GotFocus()
Dim strTemp As String
   If txtCellEditor.Visible Then
      hFlexGrid = UCase$(txtCellEditor)
         'calls the req market data text box loses focus, restricts symbols to row 1
         If txtCellEditor <> "" And hFlexGrid.Col = 1 Then
            strTemp = UCase$(txtCellEditor)
            Call reqMarketData(strTemp, hFlexGrid.Row)
         ElseIf txtCellEditor = "" Then
            'cancels market data if you leave the cell empty
            Call cancelMktData(hFlexGrid.Row)
         End If
      
      txtCellEditor.Visible = False
   End If
End Sub

Private Sub hFlexGrid_KeyDown(KeyCode As Integer, Shift As Integer)
'cancels the market data if you use the delete key remove a symbol
If KeyCode = vbKeyDelete And hFlexGrid.Col = 1 Then
      Call cancelMktData(hFlexGrid.Row)
   Else
      'just in case....not really necessary
      hFlexGrid.TextMatrix(hFlexGrid.Row, hFlexGrid.Col) = ""
   End If
End Sub

Private Sub hFlexGrid_KeyPress(KeyAscii As Integer)
   'calls the grid editor when you start typeing
   Call GridEdit(KeyAscii)
End Sub

Private Sub hFlexGrid_LeaveCell()
Dim strTemp As String
   If txtCellEditor.Visible Then
      hFlexGrid = UCase$(txtCellEditor)
         'calls the req market data when you leave a cell, restricts symbols to row 1
         If txtCellEditor <> "" And hFlexGrid.Col = 1 Then
            strTemp = UCase$(txtCellEditor)
            Call reqMarketData(strTemp, hFlexGrid.Row)
         'calls cancel market data if you go in and leave it empty
         ElseIf txtCellEditor = "" Then
            Call cancelMktData(hFlexGrid.Row)
         End If
      
      txtCellEditor.Visible = False
   End If
End Sub
Sub GridEdit(KeyAscii As Integer)
   
   With txtCellEditor
      'use correct font
      .FontName = hFlexGrid.FontName
      .FontSize = hFlexGrid.FontSize
      Select Case KeyAscii
      Case 0 To Asc(" ")
         .Text = hFlexGrid
         .SelStart = 1000
      Case Else
         .Text = Chr(KeyAscii)
         .SelStart = 1
      End Select
      'position the edit box
      .Left = hFlexGrid.CellLeft + hFlexGrid.Left
      .Top = hFlexGrid.CellTop + hFlexGrid.Top - 10
      .Width = hFlexGrid.CellWidth - 8
      .Height = hFlexGrid.CellHeight - 15
      .Visible = True
      .SetFocus
   End With
   
End Sub

Private Sub Tws1_tickPrice(ByVal id As Long, ByVal tickType As Long, ByVal price As Single)
   'populates the grid with the price information
   If tickType > 5 Then Exit Sub
   hFlexGrid.TextMatrix(id, 2 + tickType) = Format(price, "0.00")
   
End Sub
Private Sub Tws1_tickSize(ByVal id As Long, ByVal tickType As Long, ByVal size As Long)
   'populates the grid with the size information
   If tickType > 5 Then Exit Sub
   hFlexGrid.TextMatrix(id, 2 + tickType) = size
   
End Sub

Private Sub txtCellEditor_KeyDown(KeyCode As Integer, Shift As Integer)

   'handles the little text box editor for certain keystrokes
   Select Case KeyCode
         Case vbKeyEscape
            txtCellEditor.Visible = False
            hFlexGrid.SetFocus
         Case vbKeyReturn
            hFlexGrid.SetFocus
         Case vbKeyDown
            hFlexGrid.SetFocus
            DoEvents
            If hFlexGrid.Row < hFlexGrid.Rows - 1 Then
               hFlexGrid.Row = hFlexGrid.Row + 1
            End If
         Case vbKeyUp
            hFlexGrid.SetFocus
            DoEvents
            If hFlexGrid.Row > hFlexGrid.FixedRows Then
               hFlexGrid.Row = hFlexGrid.Row - 1
            End If
      End Select
      
End Sub

Private Sub txtCellEditor_KeyPress(KeyAscii As Integer)

   'noise suppression
   'If KeyAscii = vbKeyReturn Then KeyAscii = 0
   
End Sub

Public Sub reqMarketData(TWSsymbol As String, trow As Long)
Debug.Print trow
   'issue description vars
   Dim TWSsecType As String
   Dim TWSexpiry As String
   Dim TWSstrike As Single
   Dim TWSright As String
   Dim TWSexchange As String
   Dim TWScurency As String

   'stock or future for demo?
   If Combo1.ListIndex = 0 Then
      TWSsecType = "STK"
      TWSexpiry = ""
      TWSexchange = "INSTINET"
   ElseIf Combo1.ListIndex = 1 Then
      TWSsecType = "FUT"
      TWSexpiry = "200212"
      TWSexchange = "GLOBEX"
   End If

   'options and currency vars
   TWSstrike = 0
   TWSright = ""
   TWScurency = ""

   ' must have symbol, secType, and exchange
   If TWSsymbol = "" Or TWSsecType = "" Or TWSexchange = "" Then
       Beep
       MsgBox ("You must enter at least symbol, security type, and exchange.")
       Exit Sub
   End If
   'calls for the market data
   Tws1.reqMktData trow, TWSsymbol, TWSsecType, TWSexpiry, TWSstrike, TWSright, TWSexchange, TWScurency
   'displays the contract specs if a future
   hFlexGrid.TextMatrix(trow, 8) = expiryNumToAlpha(TWSexpiry)
'
End Sub
Sub cancelMktData(trow As Long)
   
   'cancel the market data
   Tws1.cancelMktData trow
   Dim iTemp As Integer
   'blanks out the entire row after you cancel the data
   For iTemp = 0 To hFlexGrid.Cols - 1
      hFlexGrid.TextMatrix(trow, iTemp) = ""
   Next iTemp
   
End Sub

Function findSymbolSlot(ByVal symbol As String) As Long
Dim lngTemp As Long
   'this function selects the right row in the grid
   With hFlexGrid
       For lngTemp = 1 To .Rows - 1
           If InStr(.TextMatrix(lngTemp, 1), symbol) Then
               findSymbolSlot = lngTemp
               Exit Function
           End If
       Next lngTemp
   End With
End Function

Function expiryNumToAlpha(ByVal strExpiry As String) As String

   'this function returns a user friendly formatted version of contract date
   Dim strTemp As String
   strTemp = Mid$(strExpiry, 3, 2)
   Select Case Right$(strExpiry, 2)
   Case "03"
      expiryNumToAlpha = "MAR" & strTemp
      Exit Function
   Case "06"
      expiryNumToAlpha = "JUN" & strTemp
      Exit Function
   Case "09"
      expiryNumToAlpha = "SEP" & strTemp
      Exit Function
   Case "12"
      expiryNumToAlpha = "DEC" & strTemp
   End Select
End Function
