Attribute VB_Name = "Module1"
Option Explicit

Private m_arrOrders() As Variant 'master array
Private m_myID As Long 'your starting point
Private m_theirID As Long 'thier starting point
Private m_nextID 'next id your going to use
Private m_incrament As Integer 'a variable to incrament by any value; 1, 5, 10 etc
'


'call on form load
Sub InitVarsNewOrderMod()

   m_myID = 3030 'set your starting level here
   
   ReDim m_arrOrders(12, 0)
   
   m_incrament = 10 'optional to incrament by other than 1

End Sub
 

Sub CaptureID(ByVal theirID As Long)
   
   'capture theirs at log on
   m_theirID = theirID
   
   
End Sub

'store your order info and give an id back to the calling sub
'this is the workhorse

Function Get_Set_NewOrderID(ByVal mirror As Variant) As Long

   Dim iTemp As Integer
   
   'find the proper id; this looks a little convaluted but stare at it
   'you will see that if the next available IB id is greater than your starting
   'point, it will back up one then add your incrament
   'otherwise it just keeps ripping out new id's per your incrament
   If m_theirID < m_myID Then
      m_nextID = m_myID
      m_myID = m_myID + m_incrament
   Else
      m_myID = m_theirID - 1 + m_incrament
      m_nextID = m_myID
      m_myID = m_myID + m_incrament
   End If
   
   'assign the id to the first element of the array
   m_arrOrders(0, UBound(m_arrOrders, 2)) = m_nextID
   
   'assign the mirror to the rest of the array
   For iTemp = 1 To UBound(m_arrOrders)
      m_arrOrders(iTemp, UBound(m_arrOrders, 2)) = mirror(iTemp)
   Next iTemp
   
   'redim and preserve your array in preperation for the next order
   ReDim Preserve m_arrOrders(12, UBound(m_arrOrders, 2) + 1)
   
   'display your array in the text box
   Call DisplayArray
   
   'finally send the new id back to the calling sub to actually make the order
   Get_Set_NewOrderID = m_nextID
   

End Function

'and a sub to display your array information
 Private Sub DisplayArray()

   Dim iTemp As Integer, iTemp2 As Integer
   Dim OrderString As String
   
   'loop through the array and build a string to display
   For iTemp = 0 To UBound(m_arrOrders, 2) - 1
      For iTemp2 = 0 To UBound(m_arrOrders)
         Select Case iTemp2
         Case LBound(m_arrOrders)
            'place the number of orders at the begining of each line
            OrderString = OrderString & "Trade: " & iTemp + 1 & ",  " & _
            "ID# " & m_arrOrders(iTemp2, iTemp) & ",   "
         Case UBound(m_arrOrders)
            'insert a line return character when you reach the end of the
            'first trade
            OrderString = OrderString & m_arrOrders(iTemp2, iTemp) & vbCrLf
         Case Else
            OrderString = OrderString & m_arrOrders(iTemp2, iTemp) & ",   "
         End Select
      Next iTemp2
   Next iTemp
   
   'display the string
   Form1.Text1 = OrderString

End Sub


