VERSION 5.00
Object = "{0A77CCF5-052C-11D6-B0EC-00B0D074179C}#1.0#0"; "Tws.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1620
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6780
   LinkTopic       =   "Form1"
   ScaleHeight     =   1620
   ScaleWidth      =   6780
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Height          =   1155
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   2
      Text            =   "Form1.frx":0000
      Top             =   0
      Width           =   6735
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   435
      Left            =   0
      TabIndex        =   1
      Top             =   1200
      Width           =   1215
   End
   Begin TWSLib.Tws Tws1 
      Height          =   495
      Left            =   300
      TabIndex        =   0
      Top             =   480
      Width           =   2235
      _Version        =   65536
      _ExtentX        =   3942
      _ExtentY        =   873
      _StockProps     =   0
   End
   Begin VB.Label Label1 
      Caption         =   "TWS API Discussion Forum Sample Project  Place an Order   Storage Array Demo"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   435
      Left            =   1260
      TabIndex        =   3
      Top             =   1200
      Width           =   3795
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Command1_Click()

   'here I have just plugged in literal values for the example
   'of course you could pull these in as variables or control properties
   'such as a combo box text or what not...
   Call PlaceNewOrder("BUY", 1, "ES", "FUT", "200209", 0, "", "GLOBEX", "", "MKT", 0#, 0#)
End Sub

Private Sub Form_Load()

   'connection call
   Tws1.Connect "", 7496
   
   'initialize your module variables
   Call InitVarsNewOrderMod
   Text1 = "PLACE ORDER DEMO:" & vbCrLf & vbCrLf & _
            "When you click Command1, a market order will fire off for 1 Contract of September " & _
            "ES. Keep clicking it and it will keep buying one at market. Each time you click, " & _
            "This box will fill with the order information stored in your array"

End Sub


'and use this for when you log out and relog in
'you can conditionally test next valid id in the module

Private Sub Tws1_nextValidId(ByVal id As Long)

   'call a module level Sub that captures the IB id on log in
   Call CaptureID(id)
   

End Sub

'now create a private sub that will handle the order routines
'the array captures the order info and stores it for you
'good idea IMHO to internally track this info and not rely
'on IB soley

Private Sub PlaceNewOrder(ByVal action As String, ByVal quantity As Long, _
   ByVal symbol As String, ByVal secType As String, ByVal expiry As String, _
   ByVal strike As Double, ByVal right As String, ByVal exchange As String, _
   ByVal curency As String, ByVal orderType As String, ByVal lmtPrice As Double, _
   ByVal auxPrice As Double)
   
   Dim mirror(12) As Variant 'left this as zero based for clarity
   
   Dim newID As Long
   
   'assign all of the arguements to the array
   'not the conspicuous absence of id in the arguements
   
   mirror(1) = action: mirror(2) = quantity: mirror(3) = symbol
   mirror(4) = secType: mirror(5) = expiry: mirror(6) = strike:
   mirror(7) = right: mirror(8) = exchange: mirror(9) = curency:
   mirror(10) = orderType: mirror(11) = lmtPrice: mirror(12) = auxPrice
   
   'pass the array out to the module
   newID = Get_Set_NewOrderID(mirror)
  
  
   'place the order
   Call Tws1.placeOrder(newID, action, quantity, symbol, secType, expiry, strike, right, exchange, _
   curency, orderType, lmtPrice, auxPrice)


End Sub

